<?php 
echo Iqiyi::parse($url);
/**
* 
*/
class Iqiyi
{
	/**
	 * [parse 解析网页获取视频ID]
	 * @param  [type] $url  [description]
	 * @return [type]       [description]
	 */
	public static function parse($url)
	{
		$html = self::curl($url);
		if($html){
			preg_match('#data-(player|drama)-isMember="([^"]+)"#iU',$html,$bool);
			preg_match('#data-(player|drama)-tvid="([^"]+)"#iU',$html,$tvids);
			preg_match('#data-(player|drama)-videoid="([^"]+)"#iU',$html,$vids);
			preg_match('#tvName:"(.*)",#iU',$html,$tvName);
			$title = $tvName[1];
			$member = $bool[2];//是否为付费视频
			$vid = $vids[2];
			$tvid = $tvids[2];
			$videoinfo = self::get_tmts_video($tvid,$vid,$member);
			return json_encode($videoinfo);
		}
	}
	/**
	 * [get_tmts_video 解析视频地址]
	 * @param  [type] $tvid [description]
	 * @param  [type] $vid  [description]
	 * @return [type]       [description]
	 */
	public static function get_tmts_video($tvid,$vid,$member)
	{
		if($member==='true'){//付费视频
			$content = self::curl(self::get_tmts_url($tvid,$vid),COOKIE_IQIYI);
		}else{
			$content = self::curl(self::get_tmts_url($tvid,$vid));
		}
		$body = preg_replace("#var tvInfoJs=#","",$content);
		$json = json_decode($body,true);
		if ($json['code']=='A00000' && isset($json['data'])){
			$data = $json['data'];
			$vidl = $data['vidl'];				//视频地址列表
			foreach($vidl as $key => $value){
				$type = $value['vd'];
				if($type==14||$type==17||$type==21||$type==1||$type==96){//过滤 H265(m3u8不支持h265编码格式)和低画质视频(流畅 标清)
					continue;
				}
				switch ($type) {
					case 1:		$def = "标清";		break;//640x360
					case 2:		$def = "高清";		break;//896x504
					case 3:		$def = "超清";		break;//1080p 
					case 4:		$def = "超高清";	break;//1280x720
					case 5:		$def = "原画";		break;//1920x1080
					case 10:	$def = "4K";		break;//3840×2160
					case 14:	$def = "H265超高清";break;//1280x720
					case 17:	$def = "H265超高清";break;//1280x720
					case 21:	$def = "H265高清";	break;//896x504
					case 96:	$def = "流畅";		break;//384x216
				}
				$m3u = $value['m3u'];
				$videoinfo["video"]["file"] = $m3u;
				$videoinfo["video"]["type"] = "video/m3u8";
			}
			return $videoinfo;
		}
	}
    public static function get_tmts_url($tvid,$vid) {//付费视频提交cookie
    	preg_match('#P00010=(\d+);#iU',COOKIE_IQIYI,$_uid);
    	preg_match('#QC006=(.*);#iU',COOKIE_IQIYI,$_qyid);
        $domain = "http://cache.m.iqiyi.com";
        $uid = empty($_uid[1])?"":$_uid[1];							//用户需从cookie里P00010获取,请自行修改
        $qyid = empty($_qyid[1])? "d56mj2ujli317a4mvdxq5i73":$_qyid[1];//用户需从cookie里QC006获取,请自行修改
        $agenttype = 13;
        $time = number_format(microtime(true),3,'','');
        $tm = mb_substr($time,0,11);
        $sgti = "{$agenttype}_{$qyid}_{$time}";
        $src = "02020031010000000000";
        $tmtsreq = "/jp/tmts/{$tvid}/{$vid}/?uid={$uid}&cupid=qc_100001_100186&platForm=h5&qyid={$qyid}&agenttype={$agenttype}&type=m3u8&rate=2&sgti={$sgti}&qdv=1&qdx=n&qdy=x&qds=0&tm={$tm}&src={$src}";//platForm=PHONE
        $vf= md5($tmtsreq."3sj8xof48xof4tk9f4tk9ypgk9ypg5ul"); //参数校验码
        $url = $domain.$tmtsreq."&vf={$vf}";
        return $url;
    }
    public static function curl($url,$cookie="")
	{
    	$params["ua"] = "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36";
    	$params["ip"] = "119.123.69.232";//伪装为固定IP，否则会报异地登录，会封号，不要更改
    	$params["cookie"] = $cookie;
      	return GlobalBase::curl($url,$params);
	}
}
?>