<?php 
$ids = Mgtv::parse($url);
echo json_encode(Mgtv::get_video_files($ids["vid"]));
/**
* 
*/
class Mgtv
{
	//============================================================================================================================
	/**
	 * [parse 解析获取视频 ID 和视频专辑 ID]
	 * @param  [type] $url [播放网址]
	 * @return [type]      [description]
	 */
	public static function parse($url)
	{
		$html = self::curl($url);
		preg_match('#cid: ([\d]+),#iU',$html,$cids);
		preg_match('#vid: ([\d]+),#iU',$html,$vids);
		return array("cid"=>$cids[1],"vid"=>$vids[1]);
	}
	/**
	 * [get_video_files 获取视频信息]
	 * @param  [type]  $vid [视频ID]
	 * @param  integer $def [视频清晰度]
	 * @return [type]       [description]
	 */
	public static function get_video_files($vid)
	{
		$api = "http://pcweb.api.mgtv.com/player/video?video_id={$vid}";
		$content = self::curl($api,COOKIE_MGTV);
		$json = json_decode($content,true);
		if($json['code']==500)
			return false;
		if (isset($json['data'])){
			$data = $json['data'];
			$info = $data['info'];//视频信息
			$domain = $data['stream_domain'];//视频域名数组
			$stream = $data['stream'];
			$count = 0;
			foreach ($stream as $key => $value) {
				$def = $value['def'];
				if(!empty($value['url'])){
					$vurl = self::get_video_url($domain[0].$value['url']);
					if (GlobalBase::is_ipad()) {
						if($def==2){
			    			$videoinfo["video"]["file"] = $vurl;
							$videoinfo["video"]["type"] = "video/m3u8";
			    			break;
			    		}
				    }else{
				    	$video[0] = $vurl;
						$video[1] = "video/m3u8";
						$video[2] = $value['name'];
						$video[3] = $def == 2 ? 10: 0;
						$videoinfo["video"][$count] = $video;
						$count++;
				    }
				}
			}
			return $videoinfo;
		}
	}
	/**
	 * [get_video_url 获取视频最终地址]
	 * @param  [type] $url [视频请求链接]
	 * @return [type]      [description]
	 */
	public static function get_video_url($url){
		$content = self::curl($url,COOKIE_MGTV);
		$data = json_decode($content,true);
		$vurl = $data["info"];
		return $vurl;
	}
	public static function curl($url,$cookie="")
	{
    	$params["ua"] = "Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36";
    	$params["cookie"] = $cookie;
      	return GlobalBase::curl($url,$params);
	}
}
 ?>